<?php

/**
 * @file
 * Rules integration for the Commerce POS Discount module.
 */

/**
 * Implements hook_rules_condition_info_alter().
 */
function commerce_pos_discount_rules_condition_info() {
  // Order: has owner.
  $conditions['commerce_pos_discount_order_has_owner'] = array(
    'label' => t('Order has owner'),
    'parameter' => array(
      'commerce_order' => array(
        'type' => 'commerce_order',
        'label' => t('Order'),
        'description' => t('The order.'),
        'wrapped' => TRUE,
      ),
      'account' => array(
        'type' => 'user',
        'label' => t('User'),
        'description' => t('User account.'),
      ),
    ),
    'module' => 'commerce_pos_discount',
    'group' => t('Commerce POS'),
    'callbacks' => array(
      'execute' => 'commerce_pos_discount_order_has_owner_build',
    ),
  );

  return $conditions;
}

/**
 * Build callback for commerce_pos_discount_order_has_owner.
 *
 * @param EntityDrupalWrapper $wrapper
 *   The wrapped entity given by the rule.
 * @param array $account
 *   A fully loaded drupal user.
 *
 * @return bool
 *   Returns true if condition is valid. false otherwise.
 */
function commerce_pos_discount_order_has_owner_build(EntityDrupalWrapper $wrapper, $account) {
  if (isset($account->uid)) {
    // If order owner matches the discount related users.
    return $account->uid == $wrapper->uid->value();
  }

  return FALSE;
}
